#!/bin/bash
# Simple places script for your pekwm menu
# 06.20.2013 by Nathan Fisher (nfisher dot sr at gmail)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#


#####################################################
# User configuration section

# What file manager are we using...
# Affects display of network:// and trash:// uri's
# filemanager="nautilus"
filemanager="thunar"
# filemanager="pcmanfm"
# filemanager="rox"

# Make the home directory entry a browsable menu
# Requires icefb.sh
BROWSE_HOME=true

# End config
####################################################

# Static places menu
echo "prog \"Filesystem\" \"drive-harddisk.png\" $filemanager file:///"
if [ "$BROWSE_HOME" = "true" ] ; then
  echo "menuprogreload Home user-home 0 icefb.sh $HOME"
else
  echo "prog \"Home\" \"user-home.png\" $filemanager file://$HOME"
fi
cat << EOF
prog "Network" "network-workgroup.png" $filemanager network:///
prog "Trash" "user-trash.png" $filemanager trash:///

separator

EOF

while read bookmark
do
  SETNAME="$(echo $bookmark | cut -s -f 2- -d ' ')"
  if [ ! "$SETNAME" = "" ] ; then
    LABEL="$SETNAME"
    bookmark=$(echo $bookmark | cut -f 1 -d ' ')
  else
    LABEL="$(basename $bookmark)"
  fi
  echo "prog $LABEL folder.png $filemanager ${bookmark}"
done<$HOME/.gtk-bookmarks
cat << EOF
separator
menu Recent document-open.png {
EOF

for uri in $(grep "href=\"file" ${HOME}/.local/share/recently-used.xbel \
    | tail -n 10 | cut -f 2 -d '"' | sed 's%file://%%') ; do
 if [ -f "${uri}" ]; then
  echo -n "prog \"$(basename ${uri})\" - "
 else
  echo -n "prog \"* $(basename ${uri})\" - "
 fi
 echo "xdg-open ${uri}"
done
cat << EOF
separator
prog "Clear Recent Documents" edit-clear.png echo > ${HOME}/.local/share/recently-used.xbel
}
EOF
